# coding: utf-8

from __future__ import unicode_literals


FILL_IN_PRIVILEGES_SQL = """
-- Временная таблица Данные + Портфолио + Заявления
CREATE TEMPORARY TABLE privilege_person_info AS (
  SELECT pd.*, pp.id p_id, d.id d_id
  FROM get_privilege_getprivilegedata pd
    LEFT JOIN pupil_portfolio pp
      ON pp.person_id = pd.risid and person_type = 1
    LEFT JOIN declaration d
      ON d.id = pd.risid and person_type = 2
);

-- Записываем связи Privilege - Exemption, отбрасывая дубли
INSERT INTO privilege_privilege
(exemption_id)
  SELECT DISTINCT
    pi.exemption
  FROM privilege_person_info pi
  WHERE NOT EXISTS (
    SELECT 1 FROM privilege_privilege pp where pi.exemption = pp.exemption_id
  )
;

-- Записываем связь Физлица и Льготы
INSERT INTO privilege_personprivilege
(person_id, privilege_id)
  SELECT DISTINCT
    pi.risid,
    pp.id
  FROM privilege_person_info pi
  LEFT JOIN privilege_privilege pp
      ON pi.exemption = pp.exemption_id
  WHERE pi.person_type = 1 AND
  NOT EXISTS (
    SELECT 1 FROM privilege_personprivilege ppp
    WHERE ppp.person_id = pi.risid AND ppp.privilege_id = pp.id
  )
;

-- Работаем с интервалами:
-- Новые записи для физлица: ставим created
INSERT INTO privilege_personprivilegeinterval
(owner_id, start_date, expiration_date, created)
  SELECT
    pp.id,
    pi.start_date,
    pi.expiration_date,
    current_timestamp
  FROM privilege_personprivilege pp
    LEFT JOIN privilege_person_info pi
      ON pi.risid = pp.person_id and pi.person_type = 1
  WHERE NOT EXISTS (
    SELECT 1 FROM privilege_personprivilegeinterval pppi
    LEFT JOIN privilege_personprivilege ppp
    ON pppi.owner_id = ppp.id
    WHERE pi.risid = ppp.person_id
  )
;

-- Обновленные записи для физлица: ставим modified
INSERT INTO privilege_personprivilegeinterval
(owner_id, start_date, expiration_date, modified)
  SELECT
    pp.id,
    pi.start_date,
    pi.expiration_date,
    current_timestamp
  FROM privilege_personprivilege pp
    LEFT JOIN privilege_person_info pi
      ON pi.risid = pp.person_id and pi.person_type = 1
  WHERE EXISTS (
    SELECT 1 FROM privilege_personprivilegeinterval pppi
    LEFT JOIN privilege_personprivilege ppp
    ON pppi.owner_id = ppp.id
    WHERE pi.risid = ppp.person_id
  ) AND
  NOT EXISTS (
    SELECT 1 FROM privilege_personprivilegeinterval pppi
    LEFT JOIN privilege_personprivilege ppp
    ON pppi.owner_id = ppp.id
    WHERE pi.risid = ppp.person_id AND
    pi.expiration_date = pppi.expiration_date
  )
;

-- Записываем связь Заявлений и Льгот
INSERT INTO privilege_declarationprivilege
(declaration_id, privilege_id)
  SELECT DISTINCT
    pi.risid,
    pp.id
  FROM privilege_person_info pi
  LEFT JOIN privilege_privilege pp
      ON pi.exemption = pp.exemption_id
  WHERE pi.person_type = 2 AND
  NOT EXISTS (
    SELECT 1 FROM privilege_declarationprivilege pdp
    WHERE pdp.declaration_id = pi.risid AND pdp.privilege_id = pp.id
  )
;

-- Работаем с интервалами:
-- Новые записи для заявления: ставим created
INSERT INTO privilege_declarationprivilegeinterval
(owner_id, start_date, expiration_date, created)
  SELECT
    dp.id,
    pi.start_date,
    pi.expiration_date,
    current_timestamp
  FROM privilege_declarationprivilege dp
    LEFT JOIN privilege_person_info pi
      ON pi.risid = dp.declaration_id and pi.person_type = 2
  WHERE NOT EXISTS (
    SELECT 1 FROM privilege_declarationprivilegeinterval pdpi
    LEFT JOIN privilege_declarationprivilege pdp
    ON pdpi.owner_id = pdp.id
    WHERE pi.risid = pdp.declaration_id
  )
;

-- Обновленные записи для заявления: ставим modified
INSERT INTO privilege_declarationprivilegeinterval
(owner_id, start_date, expiration_date, modified)
  SELECT
    dp.id,
    pi.start_date,
    pi.expiration_date,
    current_timestamp
  FROM privilege_declarationprivilege dp
    LEFT JOIN privilege_person_info pi
      ON pi.risid = dp.declaration_id and pi.person_type = 2
  WHERE EXISTS (
    SELECT 1 FROM privilege_declarationprivilegeinterval pdpi
    LEFT JOIN privilege_declarationprivilege pdp
    ON pdpi.owner_id = pdp.id
    WHERE pi.risid = pdp.declaration_id
  ) AND
  NOT EXISTS (
    SELECT 1 FROM privilege_declarationprivilegeinterval pdpi
    LEFT JOIN privilege_declarationprivilege pdp
    ON pdpi.owner_id = pdp.id
    WHERE pi.risid = pdp.declaration_id AND
    pi.expiration_date = pdpi.expiration_date
  )
;

"""
